<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Webview Docs Source: editor/form.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Webview Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="namespaces.list.html" class="dropdown-toggle" data-toggle="dropdown">Namespaces<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="socket.html">socket</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="Control.html">Control</a></li><li><a href="SessionControl.html">SessionControl</a></li><li><a href="Collection.html">Collection</a></li><li><a href="Overview.html">Overview</a></li><li><a href="Plugins.html">Plugins</a></li><li><a href="Editor.html">Editor</a></li><li><a href="FileMenu.html">FileMenu</a></li><li><a href="Form.html">Form</a></li><li><a href="Routing.html">Routing</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="global.html" class="dropdown-toggle" data-toggle="dropdown">Global<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="global.html#routing">routing</a></li><li><a href="global.html#control">control</a></li><li><a href="global.html#showSessions">showSessions</a></li><li><a href="global.html#TabButton">TabButton</a></li><li><a href="global.html#CueButton">CueButton</a></li><li><a href="global.html#CueBar">CueBar</a></li><li><a href="global.html#form">form</a></li><li><a href="global.html#editor">editor</a></li><li><a href="global.html#addGame">addGame</a></li><li><a href="global.html#createGame">createGame</a></li><li><a href="global.html#removeGame">removeGame</a></li><li><a href="global.html#inputPrompt">inputPrompt</a></li><li><a href="global.html#confirmation">confirmation</a></li><li><a href="global.html#identifyBrowser">identifyBrowser</a></li><li><a href="global.html#generateUUID">generateUUID</a></li><li><a href="global.html#namespace">namespace</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: editor/form.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* @file handles json schemes to edit imported json files
* Based on [json-editor](https://github.com/json-editor/json-editor)
* @copyright Lasse Marburg 2020
* @license GPLv3
*/

JSONEditor.defaults.iconlib = 'fontawesome5'
JSONEditor.defaults.theme = 'Plaitheme'

JSONEditor.defaults.themes.Plaitheme = class Plaitheme extends JSONEditor.AbstractTheme {

	getIndentedPanel() {
		var el = document.createElement('div');
		//var el = this._super();
		el.className = 'panel';
		return el;
	}
	getTabHolder(propertyName) {
		var pName = (typeof propertyName === 'undefined') ? "" : propertyName;
		//var el = this._super();
		var el = document.createElement('div');
		el.innerHTML = "&lt;div style='float: left; ' class='tabs' id='" + pName + "'>&lt;/div>&lt;div class='content' id='" + pName + "'>&lt;/div>&lt;div style='clear:both;'>&lt;/div>"
		return el;
	}
	getTextareaInput() {
		var el = super.getTextareaInput();
		el.style.height = '7em';
		el.className = "form_textarea";

		/*
		* escalate textarea background color based on text length (160 chars)
		* function added to focus and input events  
		*/
		function count() {
			el.title = `${this.value.length} characters || ${Math.ceil(this.value.length / 160)} sms`;
			el.setAttribute('data-charcount', this.value.length);
			switch (Math.ceil(this.value.length / 160)) {
				case 0:
					el.style.backgroundColor = 'rgba(255,255,255,1)';
					break;
				case 1:
					el.style.backgroundColor = 'rgba(255,255,255,1)';
					break;
				case 2:
					el.style.backgroundColor = 'rgba(250,200,0,0.6)';
					break;
				case 3:
					el.style.backgroundColor = 'rgba(255,153,102,0.8)';
					break;
				default:
					el.style.backgroundColor = 'rgba(204,51,0,0.8)';
					break;
			}
		}
		el.oninput = count;
		el.onfocus = count;
		el.setAttribute('onchange', count);
		el.setAttribute('data-charcount', el.value.length);

		return el;
	}
	getFormInputLabel(text) {
		var el = super.getFormInputLabel(text);
		el.style.display = 'block';
		el.style.marginBottom = '3px';
		el.style.fontWeight = 'bold';
		return el;
	}
	getFormInputDescription(text) {
		var el = super.getFormInputDescription(text);
		el.style.fontSize = '.8em';
		el.style.margin = 0;
		el.style.display = 'inline-block';
		el.style.fontStyle = 'italic';
		return el;
	}
	getTopIndentedPanel() {
		return this.getIndentedPanel();
	}
	getChildEditorHolder() {
		var el = super.getChildEditorHolder();
		el.style.marginBottom = '8px';
		return el;
	}
	getHeaderButtonHolder() {
		var el = this.getButtonHolder();
		el.style.display = 'inline-block';
		el.style.marginLeft = '10px';
		el.style.fontSize = '.8em';
		el.style.verticalAlign = 'middle';
		return el;
	}
	getTable() {
		var el = super.getTable();
		el.style.borderBottom = '1px solid #ccc';
		el.style.marginBottom = '5px';
		return el;
	}
	addInputError(input, text) {
		input.style.borderColor = 'red';

		if (!input.errmsg) {
			var group = this.closest(input, '.form-control');
			input.errmsg = document.createElement('div');
			input.errmsg.setAttribute('class', 'errmsg');
			input.errmsg.style = input.errmsg.style || {};
			input.errmsg.style.color = 'red';
			group.appendChild(input.errmsg);
		}
		else {
			input.errmsg.style.display = 'block';
		}

		input.errmsg.innerHTML = '';
		input.errmsg.appendChild(document.createTextNode(text));
	}
	removeInputError(input) {
		input.style.borderColor = '';
		if (input.errmsg) input.errmsg.style.display = 'none';
	}
	getProgressBar() {
		var max = 100, start = 0;

		var progressBar = document.createElement('progress');
		progressBar.setAttribute('max', max);
		progressBar.setAttribute('value', start);
		return progressBar;
	}
	updateProgressBar(progressBar, progress) {
		if (!progressBar) return;
		progressBar.setAttribute('value', progress);
	}
	updateProgressBarUnknown(progressBar) {
		if (!progressBar) return;
		progressBar.removeAttribute('value');
	}
}

JSONEditor.defaults.themes.Plaitheme.rules = {}

/**
* a) call [replace]{@link Form#replace} with a bunch of json data.  
* b) [load]{@link Form#load} parts of your data for potential form editors based on your schema for this data piece  
* c) [show]{@link Form#show} loaded form editors  
* d) call [getData]{@link Form#getData} to gather all loaded editors data and return it  
*
* uses [json-editor](https://github.com/json-editor/json-editor)
*
* original file slightly modified to allow easier custom styling.  
* check for CHANGED tag in comments of external/jsoneditor.js
*
* [confirmChanged]{@link Form#confirmChanged} uses {@link socket.save} from server.js to potentially save content before replace!
*/
class Form {
	constructor() {
		/** recent loaded content */
		this.content = { data: {}, changed: false }

		/** currently loaded JSONEditor Objects. Key is string path */
		this.editors = {}

		/** currently shown JSONEditor */
		this.current = null

		/** disabled/enabled status */
		this.is_locked = false
	}

	/**
	* load JSON Editor for jsondata
	*
	* @param {Object} data - JS Object the editor is populated with
	* @param {string} [path] - path to content that will be displayed in editor. With no path, editor display all current data
	* @param {Object} schema - json schema how data is to be presented
	*/
	load(json_schema, path) {
		if (path) {
			if (Object.getPath(this.editors, path) != undefined) {
				Object.getPath(this.editors, path).destroy()
			}
		} else {
			if (this.editors[this.title] != undefined) {
				this.editors[this.title].destroy()
			}
		}

		var new_div = document.createElement("div")

		var editor = new JSONEditor(new_div,
			{
				schema: json_schema,
				required_by_default: false,
				display_required_only: true
			}
		)

		editor.div = new_div

		if (path) {
			editor.setValue(Object.getPath(this.content.data, path))
		} else {
			editor.setValue(this.content.data)
		}

		editor.on('ready', function () {
			var errors = editor.validate();
			if (errors.length) {
				this.reportErrors(errors)
			} else {
				editor.watch('root', function () {
					if (!this.content.changed) {
						if (path) {
							console.log(this.content.data.name + " " + path + " changed")
						} else {
							console.log(this.content.data.name + " changed")
						}
						this.content.changed = true
					}
				}.bind(this));
			}
		}.bind(this))

		if (path) {
			editor.path = path
		} else {
			editor.path = this.content.data[this.ident]
		}
		this.editors[editor.path] = editor
	}

	/**
	* iterate through JSONEditor error message object
	*
	* @param {Object} errors - JSONEditor Error Object
	*/
	reportErrors(errors) {
		function showError(err) {
			Swal({
				title: 'Invalid JSON',
				text: "In: " + err.path + "\n\nProperty: " + err.property + "\n\nError: " + err.message,
				icon: 'warning',
			})
				.then(function (result) {
					if (errors.length) {
						showError(errors.pop())
					}
				})
		}

		showError(errors.pop())

		console.error("Invalid JSON: ");
		console.error(errors);
	}

	/**
	* collect data of all current editors.
	* If data and editor are the same (editor shows everything) replace content.data with editor value
	*
	* @todo should validate first
	*
	* @returns {Object} data that was stored including (if there are any) changes
	*/
	getData() {
		/* TODO needs to return Promise
		var errors = editor.validate();
		if(errors.length) {
			this.reportErrors(errors)
		}
		*/
		for (let edit in this.editors) {
			if (edit == this.content.data[this.ident]) {
				this.content.data = this.editors[edit].getValue()
			} else {
				Object.assignPath(this.content.data, edit, this.editors[edit].getValue())
			}
		}
		return this.content.data
	}

	/**
	* get identifier for current editor content
	* @returns {string} name/title identifier
	*/
	get title() {
		return this.content.data[this.ident]
	}

	/**
	* change title/identifier of current content
	* if current editor is based on root in current data
	* move its instance in editors object accordingly
	* @param {string} new - new title/identifier
	*/
	set title(new_title) {
		if (this.current.path == this.content.data[this.ident]) {
			console.log("Change Path of Current Editor: " + this.current.path + " to " + new_title)
			this.editors[new_title] = this.current
			delete this.editors[this.current.path]
			this.editors[new_title].path = new_title
		}
		this.content.data[this.ident] = new_title
	}

	assignID(new_id) {
		//this.setCurrent('_id', new_id)
		this.content.data['_id'] = new_id
		this.changed = true
		console.log(new_id + " ID assigned to " + this.title)
	}
	
	get id() {
		return this.content.data._id
	}

	/**
	* has current content changed
	* @returns {boolean} true if something changed
	*/
	get changed() {
		return this.content.changed
	}

	/**
	* set changed flag of current content
	* @param {boolean} ch - true if changed is supposed to be true
	*/
	set changed(ch) {
		this.content.changed = ch
	}

	/**
	* @returns {string} collection property
	*/
	get collection() {
		return this.content.collection
	}

	set locked(l) {
		this.is_locked = l
		if(this.current) {
			if(l == false) {
				this.current.enable()
			} else {
				this.current.disable()
			}
		}
	}

	get locked() {
		return this.is_locked
	}

	/**
	* replace currently diplayed editor with editor in path.
	* Has to be loaded {@link load} before
	*
	* @param {string} path - '.' seperated path
	*/
	show(path) {
		this.current_view = "table"
		if (this.editors.hasOwnProperty(path)) {
			$("#editor_div").children().detach()
			$("#editor_div").html(this.editors[path].div)
			this.current = this.editors[path]
			console.log("Show editor " + path + ". Disabled: " + this.is_locked)
			if(this.is_locked == false) {
				this.current.enable()
			} else {
				this.current.disable()
			}
		} else if (!path) {
			$("#editor_div").children().detach()
			for (let editor in this.editors) {
				$("#editor_div").append(this.editors[editor].div)
			}
		} else {
			console.error("Can't show editor " + path + ". No editor loaded for that path.")
		}
	}
	
	/**
	* show graphical flow editor
	*
	* @param {string} path - '.' seperated path
	*/
	showGraph(path) {
		this.current_view = "flow"
		if (this.editors.hasOwnProperty(path)) {
			$("#editor_div").children().detach()
			$("#editor_div").append($paper_container)
			this.current = this.editors[path]

			////////////////////////////////////////////////////////////////////
			// hack to show animation before everything freezes during load
			////////////////////////////////////////////////////////////////////
			document.getElementById("loader").style.display = "block";
			setTimeout(() => {
				plaigraph.level.import(this.editors[path].getValue());
				document.getElementById("loader").style.display = "none";
			}, 200);

			$paper_container.on('change', e => {
				this.current.setValue(plaigraph.level.getValues())
			})

		} else {
			console.error("Can't show Graphic Editor " + path + ". No editor loaded for that path.")
		}
	}
	
	/**
	* show the other editor (table or node graph) 
	*/
	toggleView() {
		console.log("Toggle from " + this.current_view + " " + this.current.path)
		if (this.current_view == "table") {
			this.showGraph(this.current.path)
		} else {
			this.show(this.current.path)
		}
	}

	/**
	* set specific value in currently shown editor
	* will be immediatly changed in visible form
	*
	* @param {string} path - '.' seperated path addressing value in currently displayed editor
	* @param {*} value - new value for property on path
	*/
	setCurrent(path, value) {
		if (path != '' &amp;&amp; path != 'root') {
			var root_path = 'root.' + path
		} else {
			var root_path = 'root'
		}

		if (this.current) {
			let sub_editor = this.current.getEditor(root_path)
			if (sub_editor) {
				sub_editor.setValue(value)
				this.content.changed = true
			} else {
				console.warn("'" + path + "' not found in current editor. Will append '" + value + "'")
				var sub_data = this.current.getValue()
				Object.assignPath(sub_data, path, value)
				this.current.setValue(sub_data)
				console.log(this.current.getValue())
				this.content.changed = true
			}
		}
	}

	/**
	* store json data that is being worked with in this form
	* (e.g. a level or all x devices)
	* Interrupt process if there were unsaved changes in current editor data
	*
	* @param {Object} data - json data to work with in form editor
	* @param {Object} collection - database collection data was stored in. Obligatory when working with save
	* @param {string} [identifier='name'] - change key of data object that identifies the data.
	*/
	replace(data, collection, identifier) {
		return new Promise(function (resolve, reject) {
			this.confirmChanged()
				.then(function (proceed) {
					if (proceed) {
						this.content.data = data
						this.content.collection = collection
						if (identifier) {
							this.ident = identifier
						} else {
							this.ident = 'name'
						}
						this.content.changed = false
						for (let edit in this.editors) {
							this.editors[edit].destroy()
							delete this.editors[edit]
						}
						resolve(true)
					} else {
						resolve(false)
					}
				}.bind(this))
				.catch(function (error) {
					console.error(new Error(error))
				})
		}.bind(this))
	}

	/**
	* remove editor from page and clear current content
	*
	* @returns {Promise} true if successfully cleared
	*/
	clear() {
		return new Promise(function (resolve, reject) {
			this.replace({}, '', '')
				.then(function (proceed) {
					resolve(proceed)
				})
		}.bind(this))
	}

	/**
	* remove editor from page and clear current content
	* without asking if content fas changed
	*/
	discard() {
		this.content = { changed: false, name: '', collection: '', data: {} }
		for (let edit in this.editors) {
			this.editors[edit].destroy()
			delete this.editors[edit]
		}
	}

	/**
	* check if current working data has changed.
	* Let user decide what to do.
	* return if user wants to go back to old data or to go on
	*
	* uses {@link socket.save} from server.js to potentially save content before replace!
	*
	* @returns {Promise} true if no changes or user wants to go on. false if user wants to cancel
	*/
	confirmChanged() {
		return new Promise(function (resolve, reject) {
			if (this.content.changed) {
				Swal({
					title: "Proceed?",
					text: "You have unsaved changes in " + this.content.data[this.ident],
					icon: "warning",
					buttons: {
						cancel: true,
						save: true,
						discard: true
					},
					dangerMode: true,
				})
					.then(function (value) {
						switch (value) {
							case "discard":
								resolve(true)
								break;
							case "save":
								socket.save(this.getData(), this.collection)
									.then(function (success) {
										if (success) {
											resolve(true)
										}
									})
								break
							default:
								resolve(false)
						}
					}.bind(this))
			} else {
				resolve(true)
			}
		}.bind(this))
	}

	/**
	* Title with an edit button that turns it into an input on click
	*
	* @param {string} title_text - text to show on creation
	* @param {string} dom_type - type of dom element the title is wrapped in
	* @param {boolean} del_btn - set to true adds a trash bin button to the title
	*
	* @returns {Object} the title Element
	*/
	editableTitle(title_text, dom_type, del_btn) {

		var $new_div = $('&lt;' + dom_type + ' class="editableTitle">&lt;/' + dom_type + '>')
		$new_div.is_active = true
		var mouse_is_over = false

		$new_div.active = function (act) {
			$new_div.is_active = act
			if (act) {
				if (mouse_is_over) {
					$new_div.children('.titleIcon').fadeTo(1, 1)
				}
				$del.click(function () {
					//var del_event = new CustomEvent('delete', {detail:{title:title_text}})
					//$new_div.dispatchEvent(del_event)
					$new_div.trigger('delete')
				})
				$edit.click(function () {
					var text = $title.text()
					var $input = $('&lt;input type=text>')
					$input.prop('value', text)
					$input.attr('size', $input.val().length)
					$input.prependTo($new_div)
					$input.focus()
					$input.select()
					$title.hide()
					$del.fadeTo(1, 0)
					$new_div.off('mouseleave')
					// remove focus on enter key
					$input.keypress(function (e) {
						if (e.which == 13) {
							$(this).blur();
						}
					})
					// finish edit when input loses focus
					$input.focusout(function () {
						$title.text($input.val())
						$title.show()
						$input.remove()
						$new_div.children('.titleIcon').fadeTo(1, 0)

						$new_div.mouseleave(function (e) {
							$new_div.children('.titleIcon').fadeTo(1, 0)
						})
						if (title_text != $input.val()) {
							$new_div.trigger('edited', { new_title: $input.val(), old_title: title_text })
							title_text = $input.val()
						}
					})
				})
			} else {
				$new_div.children('.titleIcon').off('click')
			}
		}

		var $title = $('&lt;span>' + title_text + '&lt;/span>')
		var $edit = $('&lt;i class="fa fa-pencil-alt titleIcon">&lt;/i>')
		var $del = $('&lt;i class="fa fa-trash-alt titleIcon">&lt;/i>')

		$new_div.append($title)
		$new_div.append($edit)

		if (del_btn) {
			$new_div.append($del)
		}

		$new_div.active(true)

		$new_div.mouseleave(function (e) {
			$new_div.children('.titleIcon').fadeTo(1, 0)
			mouse_is_over = false
		})

		$new_div.mouseenter(function (e) {
			mouse_is_over = true
			if ($new_div.is_active) {
				$new_div.children('.titleIcon').fadeTo(1, 1)
			}
		})

		$new_div.children('.titleIcon').fadeTo(1, 0)

		return $new_div
	}

	/**
	* creates a row of tabs with editable titles
	* loads  editors assigned to tab
	* each tab opens editor assigned to it
	*
	* @param {string} path - string path to object containing objects that become tabs
	* @param {Object} schema - schema for the content each tab is assigned to
	*
	* @returns {Object} tab row container element
	*/
	tabrow(path, schema, default_view) {
		/** contains the recent clicked tab title */
		var active_title = null
		
		this.default_view = default_view

		/** creates a tab item with event handlers and adds it to the bar element */
		this.addTab = function (item) {
			this.load(schema, path + '.' + item)

			let $title = this.editableTitle(item, 'span', true)
			let $tab = $('&lt;span class="tab">&lt;/span>')
			$tab.append($title)
			$add.before($tab)
			$title.active(false)

			$tab.click(function (e) {
				if(this.default_view == "graph") {
					this.showGraph(path + '.' + item) // GRAPH Edit
				} else {
					this.show(path + '.' + item) // Table Edit
				}
				
				//this.show(path + '.' + item)
				$bar.children('.selected').removeClass('selected')
				$tab.addClass('selected')
				if (!$title.is_active) {
					if (active_title) {
						active_title.active(false)
					}
					$title.active(true)
					active_title = $title
				}
			}.bind(this))

			$title.on('edited', function (e, param) {
				items[param.new_title] = items[item]
				delete items[item]
				Object.assignPath(this.content.data, path, items)
				console.log(Object.getPath(this.content.data, path))
				this.editors[path + '.' + param.new_title] = this.editors[path + '.' + item]
				delete this.editors[path + '.' + item]
				item = param.new_title
				this.show(path + '.' + item)

				console.log("changed tabname " + item + " to " + param.new_title)
				this.content.changed = true
			}.bind(this))

			$title.on('delete', function (e) {
				confirmation("Are you sure you want to delete chapter " + item + "?")
					.then(function (confirmed) {
						if (confirmed) {
							$tab.remove()
							this.editors[path + '.' + item].destroy()
							delete this.editors[path + '.' + item]
							delete items[item]
							Object.assignPath(this.content.data, path, items)
							console.log(item + " deleted")
							this.content.changed = true
						}
					}.bind(this))
			}.bind(this))
			return $tab
		}.bind(this)

		/** element that contains all tabs */
		var $bar = $('&lt;h3>&lt;/h3>')

		/** + button on right side. Adds new tab */
		let $add = $('&lt;span class="tab">+&lt;/span>')
		$add.click(function (e) {
			let new_tabname = "chapter"
			let c = 1
			while (items.hasOwnProperty(new_tabname)) {
				new_tabname = "chapter" + c
				c++
			}
			Object.assignPath(this.content.data, path + '.' + new_tabname, {})
			let new_tab = this.addTab(new_tabname)
			new_tab.trigger('click')
			this.content.changed = true
		}.bind(this))

		$bar.append($add)

		/** create tabs from current content */
		var items = Object.getPath(this.content.data, path)
		for (let item in items) {
			this.addTab(item)
		}
		$bar.children().eq(0).trigger('click')

		return $bar
	}
}
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
